=== gloo/transport/ibverbs/CMakeLists.txt ===
list(APPEND GLOO_TRANSPORT_SRCS
  "${CMAKE_CURRENT_SOURCE_DIR}/address.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/buffer.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/device.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/memory_region.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/pair.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/remote_key.cc"
  "${CMAKE_CURRENT_SOURCE_DIR}/unbound_buffer.cc"
  )

list(APPEND GLOO_TRANSPORT_HDRS
  "${CMAKE_CURRENT_SOURCE_DIR}/address.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/buffer.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/context.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/device.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/memory_region.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/pair.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/remote_key.h"
  "${CMAKE_CURRENT_SOURCE_DIR}/unbound_buffer.h"
  )

set(GLOO_TRANSPORT_SRCS ${GLOO_TRANSPORT_SRCS} PARENT_SCOPE)
set(GLOO_TRANSPORT_HDRS ${GLOO_TRANSPORT_HDRS} PARENT_SCOPE)
