=== debian/changelog ===
gloo (0.0~git20250912.d97133a-2) unstable; urgency=medium

  * Team upload.

  [ Spaarsh Thakkar ]
  * Improve ROCm integration

  [ Dylan Aïssi ]
  * salsa-ci: disable i386 because unsupported
  * Add patch to fix location of installed headers
  * dh_dwz: ignore some files which fail
  * Fix_header_install.patch: add forwarded link
  * d/copyright: add license for hipify_python.py
  * Remove redundant 'Priority: optional'
  * Remove redundant 'Rules-Requires-Root: no'
  * Refresh debian/control.cuda based on latest debian/control
  * Bump Standards-Version to 4.7.3, no changes required
  * Update Homepage link
  * Move gloo-rocm back to main, there is no justification for it
      being in contrib.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 16 Feb 2026 14:59:11 +0100

gloo (0.0~git20250912.d97133a-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20250912.d97133a (closes: #1096726, #1112961).
    - Prepare for PyTorch 2.8.0 packaging.
  * d/patches: refresh existing patches, remove outdated one, update metadata.
  * d/control: bump std-ver to 4.7.2 (no changes required).
  * d/{control,rules}: build with ninja, skip running flaky tests.

 -- Shengqi Chen <harry@debian.org>  Sat, 13 Sep 2025 19:02:44 +0800
