=== debian/control ===
Source: gloo
Section: science
Homepage: https://github.com/pytorch/gloo
Standards-Version: 4.7.3
Vcs-Git: https://salsa.debian.org/deeplearning-team/gloo.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/gloo
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Build-Depends: architecture-is-64-bit,
               cmake,
               debhelper-compat (= 13),
               libgtest-dev,
               libhiredis-dev,
               libibverbs-dev,
               libuv1-dev,
               ninja-build,
               pkgconf,
               mpi-default-dev

Package: libgloo-dev
Section: libdevel
Architecture: any
Depends: libgloo0 (= ${binary:Version}),
         libhiredis-dev,
         libibverbs-dev,
         ${misc:Depends}
Conflicts: libgloo-cuda-dev
Replaces: libgloo-cuda-dev
Description: Collective communications library (development files)
 Gloo is a collective communications library. It comes with a number of
 collective algorithms useful for machine learning applications. These
 include a barrier, broadcast, and allreduce.
 .
 Transport of data between participating machines is abstracted so that
 IP can be used at all times, or InifiniBand (or RoCE) when available.
 In the latter case, if the InfiniBand transport is used, GPUDirect can
 be used to accelerate cross machine GPU-to-GPU memory transfers.
 .
 Where applicable, algorithms have an implementation that works with system
 memory buffers, and one that works with NVIDIA GPU memory buffers. In the
 latter case, it is not necessary to copy memory between host and device;
 this is taken care of by the algorithm implementations.
 .
 This package ships the development files.

Package: libgloo0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: libgloo-cuda-0
Replaces: libgloo-cuda-0
Description: Collective communications library (shared object)
 Gloo is a collective communications library. It comes with a number of
 collective algorithms useful for machine learning applications. These
 include a barrier, broadcast, and allreduce.
 .
 Transport of data between participating machines is abstracted so that
 IP can be used at all times, or InifiniBand (or RoCE) when available.
 In the latter case, if the InfiniBand transport is used, GPUDirect can
 be used to accelerate cross machine GPU-to-GPU memory transfers.
 .
 Where applicable, algorithms have an implementation that works with system
 memory buffers, and one that works with NVIDIA GPU memory buffers. In the
 latter case, it is not necessary to copy memory between host and device;
 this is taken care of by the algorithm implementations.
 .
 This package ships the shared object for Gloo.
