## gloo 20020927

=== Makefile ===
#
# Makefile:
#
# Copyright (c) 2002 James McKenzie <james@fishsoup.dhs.org>,
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# $Id: Makefile,v 1.3 2002/09/27 11:00:09 root Exp $
#
# $Log: Makefile,v $
# Revision 1.3  2002/09/27 11:00:09  root
# #
#
# Revision 1.2  2002/09/27 10:51:23  root
# #
#
# Revision 1.1  2002/09/27 10:51:16  root
# Initial revision
#
#
ALL=gloo tcp2stdio serial2stdio
SRCS=gloo.c tcp2stdio.c serial2stdio.c
CFLAGS=-s

ifeq (.maintainer,$(wildcard .maintainer))
  include .maintainer
endif


all:  ${ALL}

docs: gloo.1

gloo.1:gloo.sgml
	/usr/bin/docbook-to-man $< > $@ || /bin/rm -f $@

clean:
	/bin/rm -f ${ALL} core *~ *.o a.out *.BAK

checkin:
	ci -m# -l ${SRCS} gloo.sgml Makefile

tidy: checkin
	indent -i2 -ts0 ${SRCS}
